
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/graphics.h>
#include <proto/intuition.h>

#define MAXVEC 10  /* maximale Anzahl Area-Funktionsaufrufe */


int main (void)

{
struct Window *win;
struct MsgPort *port;
struct IntuiMessage *mess;
BOOL weiter;
struct RastPort *rp;
struct TmpRas tmpras;      /* TmpRas-Struktur */
UBYTE *tmpbuf;             /* Puffer fr TmpRas */
ULONG rassize;             /* Gre des TmpRas-Puffer */
struct AreaInfo areainfo;  /* AreaInfo-Struktur */
UBYTE *areabuf;            /* Puffer fr AreaInfo */

win = OpenWindowTags (NULL,
	WA_Left,400,WA_Top,300,
	WA_InnerWidth,100,
	WA_InnerHeight,100,
	WA_Title,"Fenster",
	WA_Flags,WFLG_CLOSEGADGET|WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_ACTIVATE|WFLG_GIMMEZEROZERO|WFLG_NOCAREREFRESH,
	WA_IDCMP,IDCMP_CLOSEWINDOW|IDCMP_VANILLAKEY,
	TAG_END);

if (win != NULL)
	{
	rp = win->RPort;

	rassize = RASSIZE(win->GZZWidth,win->GZZHeight);
	tmpbuf = AllocVec (rassize,MEMF_CHIP|MEMF_CLEAR);      /* Puffer fr TmpRas anlegen */
	if (tmpbuf != NULL)
		{
		InitTmpRas (&tmpras,tmpbuf,rassize);               /* TmpRas initialisieren */
		rp->TmpRas = &tmpras;                              /* und in RastPort eintragen */
		}

	areabuf = AllocVec (5*MAXVEC,MEMF_CLEAR);              /* Puffer fr AreaInfo anlegen */
	if (areabuf != NULL)                                   /* (5 Bytes pro Area-Funktionsaufruf) */
		{
		InitArea (&areainfo,areabuf,MAXVEC);               /* AreaInfo initialisieren */
		rp->AreaInfo = &areainfo;                          /* und in RastPort eintragen */
		}

	SetAPen (rp,2);            /* Farbe setzten (Stift 2 ist meistens wei) */
	AreaMove (rp,10,50);       /* Startecke setzen */
	AreaDraw (rp,50,10);       /* Nchste Ecke setzen */
	AreaDraw (rp,90,50);
	AreaDraw (rp,50,90);
	AreaEnd (rp);              /* Area abschlieen und fllen */
	                           /* die Linie zum Startpunkt wird automatisch ergnzt */

	                           /* Zum Vergleich: den Rahmen mit Linien nachziehen */
	SetAPen (rp,1);            /* Stift 1 = schwarz */
	Move (rp,10,50);
	Draw (rp,50,10);
	Draw (rp,90,50);
	Draw (rp,50,90);
	Draw (rp,10,50);           /* Diesmal mu die letzte Linie mitgezeichnet werden */


	port = win->UserPort;
	weiter = TRUE;
	while (weiter)
		{
		WaitPort (port);
		mess = (struct IntuiMessage *) GetMsg (port);
		while (mess != NULL)
			{
			switch (mess->Class)
				{
			case IDCMP_CLOSEWINDOW:
				weiter = FALSE;
				break;
			case IDCMP_VANILLAKEY:
				if (mess->Code == 0x1b)
					weiter = FALSE;
				}
			ReplyMsg ((struct Message *) mess);
			mess = (struct IntuiMessage *) GetMsg (port);
			}
		}

	if (tmpbuf != NULL)
		{
		rp->TmpRas = NULL;   /* TmpRas aus RastPort entfernen */
		FreeVec (tmpbuf);    /* Puffer freigeben */
		}

	if (areabuf != NULL)
		{
		rp->AreaInfo = NULL; /* AreaInfo aus RastPort entfernen */
		FreeVec (areabuf);   /* Puffer freigeben */
		}

	CloseWindow (win);
	}
else
	{
	Printf ("Konnte Fenster nicht ffnen !\n");
	return (RETURN_FAIL);
	}

return (RETURN_OK);
}
